globalvar GNengiBull;
GNengiBull = object_add();

object_event_add(GNengiBull, ev_create, 0, '
    speed = 8;
    image_speed = 0;
    sprite_index = GNengiBullS;
    alarm[0] = 60 / global.delta_factor;

    gunSetSolids();
    // Try to get outside of the wallmask if were in it.
    if(!place_free(x, y)) move_outside_solid(0, 18);
    if(!place_free(x, y)) move_outside_solid(180, 36);
    if(!place_free(x, y))
    {
        move_outside_solid(0, 18);
        move_outside_solid(90, 18);
    }
    gunUnsetSolids();
');

object_event_add(GNengiBull, ev_alarm, 0, '
    instance_destroy();
    instance_create(x,y,Explosion);
    playsound(x, y, ExplosionSnd);
    
    with(Character) {
        if (point_distance(x,0,other.x, 0) < 80 && player.team != other.ownerPlayer.team && ubered == 0) {
            damageCharacter(other.ownerPlayer, id, 30);
            if (lastDamageDealer != other.ownerPlayer and lastDamageDealer != player)
            {
                secondToLastDamageDealer = lastDamageDealer;
                alarm[4] = alarm[3]
            }
            alarm[3] = ASSIST_TIME;
            lastDamageDealer = other.ownerPlayer;
            lastDamageSource = GENERATOR_EXPLOSION;
            dealFlicker(id);
        }
    }
    with(Sentry) {
        if (point_distance(x,0,other.x, 0) < 70 && team != other.ownerPlayer.team) {
            damageSentry(other.ownerPlayer, id, 30);
            lastDamageDealer = other.ownerPlayer;
            lastDamageSource = FRAG_BOX;
        }
    }
    with(Generator) {
        if (point_distance(x,0,other.x, 0) < 70 && team != other.ownerPlayer.team && object_index != MOBAturret) damageGenerator(other.ownerPlayer, id, 30);
    }
');

object_event_add(GNengiBull, ev_collision, GNengiBull, '
    if (other.ownerPlayer.team != ownerPlayer.team) speed = 0;
');

object_event_add(GNengiBull, ev_collision, Character, '
    if (other.team != ownerPlayer.team) {
        with(other) {
            motion_add(other.direction, other.speed*1.3);
        }
        
        if (other.lastDamageDealer != ownerPlayer and other.lastDamageDealer != other.player)
        {
            other.secondToLastDamageDealer = other.lastDamageDealer;
            other.alarm[4] = other.alarm[3]
        }
        other.alarm[3] = ASSIST_TIME;
        other.lastDamageDealer = ownerPlayer;
        other.lastDamageSource = KILL_BOX;
    }
');

object_event_add(GNengiBull, ev_collision, Sentry, '
    // squish sentries
    if (ownerPlayer.team != other.team && other.object_index == Sentry) other.hp = 0;
');

object_event_add(GNengiBull, ev_collision, MOBAbot, '
    if (ownerPlayer.team != other.team) {
        with(other) {
           state = 0;
           alarm[9] = 10 / global.delta_factor;
           motion_add(other.direction, other.speed*1.3);
        }
    }
');

object_event_add(GNengiBull, ev_step, ev_step_begin, '
    gunSetSolids();    
    if (place_free(x, y)) {
        hspeed *= global.delta_factor;
    
        if(!place_free(x+hspeed, y)) {
            var hit;
            hit = false;
        
            if (abs(hspeed) > 6) {
                if(place_free(x + sign(hspeed)*6, y - 6)) y -= 6; // hop up the step.
                else if(place_free(x + sign(hspeed)*6, y + 6) and abs(hspeed) >= abs(vspeed)) y += 6;
                else hit = true;
            }
            
            if(place_free(x + hspeed, y - 6)) y -= 6; // hop up the step.
            else if(place_free(x + hspeed, y + 6) and abs(hspeed) >= abs(vspeed)) y += 6;
            else hit = true;

            if (hit) {
               speed = 0;
               really_move_contact_solid(direction, speed);
            }
        }
        
        hspeed /= global.delta_factor;
    } else speed = 0;
    
    gunUnsetSolids();
    x += hspeed * global.delta_factor;
    x -= hspeed;
');

object_event_add(GNengiBull, ev_draw, 0, '
    draw_sprite_ext(GNengiBullS, floor(image_index) + ownerPlayer.team*8, x, y, image_xscale, 1, 0, c_white, 1);
    image_index += 0.4 * global.delta_factor;
    if (image_index >= 8) {
        image_index = 0;
    }
');